#ifndef MALLOC_H
#define MALLOC_H

typedef unsigned long  simm_id;

#pragma CALLEE-SAVES addr5,addr6,addr7,simm_id_from_pointer

simm_id simm_malloc(unsigned int num_bytes);
void simm_free(simm_id addr32);
xdata void * addr5(simm_id addr32);
xdata void * addr6(simm_id addr32);
xdata void * addr7(simm_id addr32);
simm_id simm_id_from_pointer(xdata void *ptr);


/* These addrX_val variables can be used to backup the
 * current address mapping (they may be needed by a
 * higher-level calling function).  For examples:
 *
 * void some_subroutine(simm_id filelist)
 * {
 *    unsigned int addr7_backup;
 *    filelist struct *f_ptr;
 *
 *    addr7_backup = addr7_val;  //save addr7_val used by calling code
 *    f_ptr = addr7(filelist);
 *    // code that uses f_ptr 
 *    addr7_val = addr7_backup;  //restore addr7_val before returning
 * }
 *
 */

extern volatile xdata at 0xFF0A unsigned int addr5_val;
extern volatile xdata at 0xFF0C unsigned int addr6_val;
extern volatile xdata at 0xFF0E unsigned int addr7_val;

#endif

