#ifndef PARAMS_H
#define PARAMS_H

#include "parse.h"

/* Ensure a default value is added in params.c if adding a new param here */
typedef enum {
   PARAM_UNUSED0,
   PARAM_ATTN,
   PARAM_TREBLE,
   PARAM_BASS,
   PARAM_TREBLE_FREQ_UNUSED,
   PARAM_TREBLE_FREQ_INDEX,
   PARAM_BASS_FREQ_UNUSED,
   PARAM_BASS_FREQ_INDEX,
   PARAM_PLAY_MODE,
   PARAM_PLST_INDEX_HI,
   PARAM_PLST_INDEX_LO,
   PARAM_TRACK_INDEX_HI,
   PARAM_TRACK_INDEX_LO,
   PARAM_RESUME,
   PARAM_SCROLL_SPEED,
   PARAM_DISK_SPIN_DELAY,
   PARAM_SCREEN_TIMEOUT,
   PARAM_COUNT   /* must be last */
} param_t;   

extern xdata unsigned char param_value[PARAM_COUNT];

void param_init();
void eparam_display();
unsigned char eparam_user_action(event_t event);
void eparam_write_flash();
void param_restart_write_timer();
unsigned char param_default_value(param_t param);
void param_write(param_t param);
unsigned int param_screen_timeout();

#endif
